> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Create Company Permission

POST https://api-b2b.bigcommerce.com/api/v3/io/companies/permissions
Content-Type: application/json

Create a custom Company permission.

Note that the permission’s `name` and `code` values cannot match an existing permission.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/b2b/management/company/company-roles-and-permissions/post-stores-companies-permissions

## Authentication

- `X-Auth-Token` header (required) — | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts). | For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).
- `X-Store-Hash` header (required) — | Header | Argument | Description | |:-------|:---------|:------------| | `X-Store-Hash` | `store_hash` | The unique store hash associated with a BigCommerce store that has B2B Edition enabled. |

## Request

### Body (application/json)

This endpoint expects a permission_REQUEST.

- `name` (string, required) — The name of the Company permission.
- `description` (string, required) — The simple description for the Company permission. See [Permission Codes](/developer/api-reference/rest/b2b/management/company/companies#permission-code) for a more detailed description of each predefined Company permission.
- `code` (string, required) — The [code string](/developer/api-reference/rest/b2b/management/company/companies#permission-code) of the Company permission.
- `moduleName` (string, optional) — The name of the module to which the permission belongs. This corresponds to the organizational section containing the permission when managing Company roles from the B2B Edition control panel.

## Response

### 200

OK

- `code` (integer, optional, default: 200)
- `data` (permission_RESPONSE, optional)
- `meta` (CompaniesPermissionsPostResponsesContentApplicationJsonSchemaMeta, optional)

## Types

### permission_RESPONSE

- `name` (string, optional) — The name of the Company permission.
- `description` (string, optional) — The simple description for the Company permission. See [Permission Codes](/developer/api-reference/rest/b2b/management/company/companies#permission-code) for a more detailed description of each predefined Company permission.
- `code` (string, optional) — The [code string](/developer/api-reference/rest/b2b/management/company/companies#permission-code) of the Company permission.
- `moduleName` (string, optional) — The name of the module to which the permission belongs. This corresponds to the organizational section containing the permission when managing Company roles from the B2B Edition control panel.
- `id` (integer, optional)
- `isCustom` (boolean, optional) — Indicates whether a Company permission is predefined or custom. If `true`, the permission is custom. If `false`, it is predefined.

### CompaniesPermissionsPostResponsesContentApplicationJsonSchemaMeta

- `message` (string, optional, default: SUCCESS)

## Examples

**Request**

```json
{
  "name": "Get addresses",
  "description": "Get addresses",
  "code": "get_addresses",
  "moduleName": "address"
}
```

**Response**

```json
{
  "code": 200,
  "data": {
    "name": "Get addresses",
    "description": "Get addresses",
    "code": "get_addresses",
    "moduleName": "address",
    "id": 1,
    "isCustom": false
  },
  "meta": {
    "message": "SUCCESS"
  }
}
```

**SDK Code**

```python Create a company permission
import requests

url = "https://api-b2b.bigcommerce.com/api/v3/io/companies/permissions"

payload = {
    "name": "Get addresses",
    "description": "Get addresses",
    "code": "get_addresses",
    "moduleName": "address"
}
headers = {
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Create a company permission
const url = 'https://api-b2b.bigcommerce.com/api/v3/io/companies/permissions';
const options = {
  method: 'POST',
  headers: {'X-Auth-Token': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"name":"Get addresses","description":"Get addresses","code":"get_addresses","moduleName":"address"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Create a company permission
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api-b2b.bigcommerce.com/api/v3/io/companies/permissions"

	payload := strings.NewReader("{\n  \"name\": \"Get addresses\",\n  \"description\": \"Get addresses\",\n  \"code\": \"get_addresses\",\n  \"moduleName\": \"address\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Create a company permission
require 'uri'
require 'net/http'

url = URI("https://api-b2b.bigcommerce.com/api/v3/io/companies/permissions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Get addresses\",\n  \"description\": \"Get addresses\",\n  \"code\": \"get_addresses\",\n  \"moduleName\": \"address\"\n}"

response = http.request(request)
puts response.read_body
```

```java Create a company permission
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api-b2b.bigcommerce.com/api/v3/io/companies/permissions")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Get addresses\",\n  \"description\": \"Get addresses\",\n  \"code\": \"get_addresses\",\n  \"moduleName\": \"address\"\n}")
  .asString();
```

```php Create a company permission
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api-b2b.bigcommerce.com/api/v3/io/companies/permissions', [
  'body' => '{
  "name": "Get addresses",
  "description": "Get addresses",
  "code": "get_addresses",
  "moduleName": "address"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Create a company permission
using RestSharp;

var client = new RestClient("https://api-b2b.bigcommerce.com/api/v3/io/companies/permissions");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Get addresses\",\n  \"description\": \"Get addresses\",\n  \"code\": \"get_addresses\",\n  \"moduleName\": \"address\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Create a company permission
import Foundation

let headers = [
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "Get addresses",
  "description": "Get addresses",
  "code": "get_addresses",
  "moduleName": "address"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api-b2b.bigcommerce.com/api/v3/io/companies/permissions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```